mplot <-function(x,Y,mtype=rep("l",30),mlty=rep(1,30),...)
{

plot(NA,xlim=range(x),ylim=range(Y),...)
for (i in 1:ncol(Y))
{
lines(x,Y[,i],type=mtype[i],lty=mlty[i])
}
}


mean2 <- function(data, f)
     sum(data*f)/sum(f)


cdis <-function(z,x) 
{
for (i in 1:length(x))
{
   F[i] <-sum(z<=x[i])/length(z);
}
F
}

qqlplot<-function(x,y,...)
{
qqplot(x,y,...);
x1<-quantile(x,0.25);
x2<-quantile(x,0.75);
y1<-quantile(y,0.25);
y2<-quantile(y,0.75);
m<-(y1-y2)/(x1-x2);
q<-y2-m*x2;
abline(q,m);
}

air.rg <- function(data, mle)
     rexp(length(data), 1/mle)
################################################################

par(ask=TRUE) 
library(boot)
set.seed(555)

data(aircondit)

x<- aircondit$hours

N<-length(x);
mu.hat<-mean(x);
I<-0:600;
empF<-cdis(x,I);

expF<-1-exp(-I/mu.hat);

mplot(I,cbind(empF,expF),xlab='Failure time',ylab='Distribution function',
mtype=c('o','l'))


qqlplot(rexp(length(x)),x,xlab='Quantiles of standard exponential',
ylab='Quantiles airco')



#################################################################""


par(ask=TRUE) 



N<-length(aircondit$hours)
mu.hat<-mean(aircondit$hours)
var.mu.hat<-(mu.hat^2)/N
air.p.boot <- boot(aircondit$hours, mean, R=999, sim="parametric",
                 ran.gen=air.rg, mle=mean(aircondit$hours))

q.p.inf<-quantile(air.p.boot$t-air.p.boot$t0,0.05)
q.p.sup<-quantile(air.p.boot$t-air.p.boot$t0,0.95)




B <- seq(10,1000,100); lB<-length(B);
R<-12;
q.np.b.inf<-matrix(0,lB ,R );
q.np.b.sup<-matrix(0,lB,R);
mean.np<-matrix(0,lB,R);
var.np<-matrix(0,lB,R);
q.p.b.inf<-matrix(0,lB,R);
q.p.b.sup<-matrix(0,lB,R);
mean.p<-matrix(0,lB,R);
var.p<-matrix(0,lB,R);

########## PARAMETRIC

for (r in 1:R)
{
cnt<-1;
for (b in B)

{

air.p.boot <- boot(aircondit$hours, mean, R=b, sim="parametric",
                 ran.gen=air.rg, mle=mean(aircondit$hours))

mean.p[cnt,r]<-mean(air.p.boot$t-mu.hat)
var.p[cnt,r]<-var(air.p.boot$t)

q.p.b.inf[cnt,r]<-quantile(air.p.boot$t-mu.hat,0.05)
q.p.b.sup[cnt,r]<-quantile(air.p.boot$t-mu.hat,0.95)
cnt<-cnt+1
}

}

mplot(B,cbind(mean.p[1:(cnt-1),],rep(0,cnt-1)),main='Parametric bias',
xlab='Number of boostrap replicates',ylab='', mlty=c(rep(1,R),2));

mplot(B,cbind(var.p[1:(cnt-1),],rep(var.mu.hat,cnt-1)),
main='Parametric Variance', mlty=c(rep(1,R),2),xlab='Number of boostrap replicates',ylab='');

mplot(B,cbind(q.p.b.sup[1:(cnt-1),],q.p.b.inf[1:(cnt-1),],rep(q.p.inf,cnt-1),rep(q.p.sup,cnt-1)),
main='Parametric quantiles', xlab='Number of boostrap replicates',ylab='',mlty=c(rep(1,2*R),3,3));

########## NON PARAMETRIC
for (r in 1:R)
{
cnt<-1;
for (b in B)

{
air.np.boot <- boot(aircondit$hours, mean2, R=b,stype='f')


mean.np[cnt,r]<-mean(air.np.boot$t-mu.hat)
var.np[cnt,r]<-var(air.np.boot$t)

q.np.b.inf[cnt,r]<-quantile(air.np.boot$t-mu.hat,0.05)
q.np.b.sup[cnt,r]<-quantile(air.np.boot$t-mu.hat,0.95)
cnt<-cnt+1
}
}

mplot(B,cbind(mean.np[1:(cnt-1),],rep(0,cnt-1)),main='Nonparametric bias',
xlab='Number of boostrap replicates',ylab='', mlty=c(rep(1,R),2));

mplot(B,cbind(var.np[1:(cnt-1),],rep(var.mu.hat,cnt-1)),
main='Nonparametric Variance', mlty=c(rep(1,R),2),xlab='Number of boostrap replicates',ylab='');

mplot(B,cbind(q.np.b.sup[1:(cnt-1),],q.np.b.inf[1:(cnt-1),],rep(q.p.inf,cnt-1),rep(q.p.sup,cnt-1)),
main='Nonparametric quantiles', xlab='Number of boostrap replicates',ylab='',mlty=c(rep(1,2*R),3,3));




