mplot <-function(x,Y,mtype=rep("l",10),mlty=rep(1,10),...)
{

plot(NA,xlim=range(x),ylim=range(Y),...)
for (i in 1:ncol(Y))
{
lines(x,Y[,i],type=mtype[i],lty=mlty[i])
}
}
par(ask=TRUE) 
air.rg <- function(data, mle)
     rexp(length(data), 1/mle)

data(aircondit)
N<-length(aircondit$hours)
mu.hat<-mean(aircondit$hours)
var.mu.hat<-(mu.hat^2)/N
air.p.boot <- boot(aircondit$hours, mean, R=999, sim="parametric",
                 ran.gen=air.rg, mle=mean(aircondit$hours))

q.p.inf<-quantile(air.p.boot$t-air.p.boot$t0,0.05)
q.p.sup<-quantile(air.p.boot$t-air.p.boot$t0,0.95)




##NON PARAMETRIC

mean2 <- function(data, f)
     sum(data*f)/sum(f)


B <- seq(10,1000,10);

q.np.b.inf<-matrix(0,1000,1);
q.np.b.sup<-matrix(0,1000,1);
mean.np<-matrix(0,1000,1);
var.np<-matrix(0,1000,1);
q.p.b.inf<-matrix(0,1000,1);
q.p.b.sup<-matrix(0,1000,1);
mean.p<-matrix(0,1000,1);
var.p<-matrix(0,1000,1);
########## PARAMETRIC
cnt<-1;
for (b in B)

{

air.p.boot <- boot(aircondit$hours, mean, R=b, sim="parametric",
                 ran.gen=air.rg, mle=mean(aircondit$hours))

mean.p[cnt]<-mean(air.p.boot$t-mu.hat)
var.p[cnt]<-var(air.p.boot$t)

q.p.b.inf[cnt]<-quantile(air.p.boot$t-mu.hat,0.05)
q.p.b.sup[cnt]<-quantile(air.p.boot$t-mu.hat,0.95)
cnt<-cnt+1
}



mplot(B,cbind(mean.p[1:(cnt-1)],rep(0,cnt-1)),main='Parametric bias',
xlab='Number of boostrap replicates',ylab='', mtype=c("o","l"));

mplot(B,cbind(var.p[1:(cnt-1)],rep(var.mu.hat,cnt-1)),
main='Parametric Variance', mtype=c("o","l"),xlab='Number of boostrap replicates',ylab='');

mplot(B,cbind(q.p.b.sup[1:(cnt-1)],q.p.b.inf[1:(cnt-1)],rep(q.p.inf,cnt-1),rep(q.p.sup,cnt-1)),
main='Parametric quantiles', xlab='Number of boostrap replicates',ylab='',mlty=c(1,1,3,3));

########## NON PARAMETRIC
cnt<-1;
for (b in B)

{
air.np.boot <- boot(aircondit$hours, mean2, R=b,stype='f')


mean.np[cnt]<-mean(air.np.boot$t-mu.hat)
var.np[cnt]<-var(air.np.boot$t)

q.np.b.inf[cnt]<-quantile(air.np.boot$t-mu.hat,0.05)
q.np.b.sup[cnt]<-quantile(air.np.boot$t-mu.hat,0.95)
cnt<-cnt+1
}


mplot(B,cbind(var.np[1:(cnt-1)],rep(var.mu.hat,cnt-1)),
main='Nonparametric Variance', mtype=c("o","l"),xlab='Number of boostrap replicates',ylab='');

mplot(B,cbind(mean.np[1:(cnt-1)],rep(0,cnt-1)),main='Nonparametric bias',
xlab='Number of boostrap replicates',ylab='', mtype=c("o","l"));


mplot(B,cbind(q.np.b.sup[1:(cnt-1)],q.np.b.inf[1:(cnt-1)],rep(q.p.inf,cnt-1),rep(q.p.sup,cnt-1)),
main='Nonparametric quantiles', xlab='Number of boostrap replicates',ylab='',mlty=c(1,1,3,3));

